(DEFUN RTD (RAD)
       (* (/ RAD pi) 180)
)

(DEFUN DTR (DEG)
       (* (/ DEG 180) pi)
)

(defun SPEEDO (counter total string / perc)
  (if (/= counter 0)
    (progn
      (setq perc (itoa (fix (* 100.0 (/ (float counter) (float total))))))
      (princ (strcat string perc "%"))
    )
  )
)

(defun C:MCLICK (/ e d g c c1 c2 n p np r xs ys zs rn z)

 (if (not enviroment_off)(load "14enviroment.lsp"))
 (enviroment_off)
 (command "_layer" "thaw" "-construct-a" "set" "-construct-a" "")

(command "regenauto" "off")
  (setvar "cmdecho" 0)
  (setq os (getvar "osmode"))
(setvar "OSMODE" 0)
  (command "undo" "mark")
  (setq h (getint "\nConfirm Height:  <1>2400  <2>2100  <3>1000  <4>900  <5>Type it:<1> "))
  (if (= 1 h) (setq h "24")
    (if (= 2 h) (setq h "21")
      (if (= 3 h) (setq h "10")
        (if (= 4 h) (setq h "09")
          (if (= 5 h)
            (progn
              (setq h (getstring "\nSpecial Height in cm: "))
              (if (= 1 (strlen h)) (setq h (strcat "00" h))
                (if (= 2 (strlen h)) (setq h (strcat "0" h))
                  (setq h "24")
                )
              )
            )
            (setq h "24")
          )
        )
      )
    )
  )

  (setq c1 (getint "\nConfirm Colour one: <1>Black <2>Blue <3>Grey <4>Green <5>Red <6>White:<1> "))
  (if (= 1 c1) (setq c1 "7")
    (if (= 2 c1)
      (progn
        (setq c1 "5") (setq c2 "5")
      )
      (if (= 3 c1)
        (progn
          (setq c1 "8") (setq c2 "8")
        )
        (if (= 4 c1)
          (progn
            (setq c1 "3") (setq c2 "3")
          )
          (if (= 5 c1)
            (progn
              (setq c1 "1") (setq c2 "1")
            )
            (if (= 6 c1)
              (progn
                (setq c1 "0") (setq c2 "0")
              )
              (setq c1 "7")
            )
          )
        )
      )
    )
  )

  (if (= c1 "7")
    (setq c2 (getint "\nConfirm Colour two: <1>Black <2>Blue <3>Grey <4>Green <5>Red <6>White:<1> "))
  )
  (if (= 1 c2) (setq c2 "7")
    (if (= 2 c2) (setq c2 "5")
      (if (= 3 c2) (setq c2 "8")
        (if (= 4 c2) (setq c2 "3")
          (if (= 5 c2) (setq c2 "1")
            (if (= 6 c2) (setq c2 "0")
              (if (= nil c2) (setq c2 "7"))
            )
          )
        )
      )
    )
  )
  (prompt "Select Constructed area for modification:")
  (setq g (ssget '((0 . "INSERT"))))
  (setq c 0)			;assigns value 0 to variable c - insert point
  (repeat (sslength g)			;returns the number of entitys in selection set g
    (setq e (ssname g c))		;returns the name of an element  in selection set g
    (setq d (entget e))
    (setq n (cdr (assoc 2 d)))		;n=block name
    (setq p (cdr (assoc 10 d)))		;p=insertion point 3D point
    (setq r (RTD (cdr (assoc 50 d)))) 	;r=rotaion in radians
    (setq xs (cdr (assoc 41 d)))		;x axis scale factor
    (setq ys (cdr (assoc 42 d)))		;y axis scale factor
    (setq zs (cdr (assoc 43 d)))		;z axis scale factor

    (if (wcmatch n "F#*")
      (setq rn (strcat (substr n 1 4) c1 c2))
      (if (wcmatch n "FA#*")
        (setq rn (strcat (substr n 1 5) c1 c2))
        (if (wcmatch n "W#*")
          (setq rn (strcat (substr n 1 6) c1 c2))
          (if (wcmatch n "P#*")
            (setq rn (strcat (substr n 1 4) h c1 c2))
            (if (wcmatch n "R#*")
              (setq rn (strcat (substr n 1 4) h c1 c2))
            (if (wcmatch n "OU#*")
              (setq rn (strcat (substr n 1 4) h c1 c2))
              (if (wcmatch n "EU*")
                (setq rn (strcat (substr n 1 2) h "0"))
                (setq rn n)
              )
            )
          )
        )
      )
    )
)

    (if (= "24" h) (setq z 0.0)
      (if (= "21" h) (setq z -30.0)
        (if (= "10" h) (setq z -140.0)
          (if (= "09" h) (setq z -150.0)
            (setq z (- (* 10 (atof h)) 240))
          )
        )
      )
    )

    (if (OR (wcmatch rn "W#*") (wcmatch rn "P#*") (wcmatch rn "R#*") (wcmatch rn "OU##*")
            (wcmatch rn "CT*") (wcmatch rn "CF*") (wcmatch rn "EU*")
        )
      (setq np p)
      (progn
        (setq np (list (car p) (cadr p) z))
        (setq d (subst (cons 10 np) (assoc 10 d) d))
        (setq d (entmod d))
      )
    )

    (if (OR (findfile (strcat rn ".dwg")) (tblsearch "BLOCK" rn))
      (progn
        (entdel e)
        (command "insert" rn np "xyz" xs ys zs r)
      )
      (if (wcmatch rn "F###7*")
        (prompt (strcat "\nFile " (strcat rn ".dwg") " could not be found in the Drawing or on the Path.\n"))
      )
    )
    (setq c (1+ c))
    (SPEEDO c (sslength g) "\rProcessing.....")
  )
  (command "redraw")
  (setvar "osmode" os)
  (setvar "cmdecho" 1)
  (setvar "filedia" 1)
(command "regenauto" "on")
(enviroment_on)
  (princ)
)
(prompt "\nUse MCLICK to modify click construction.") (princ)
